<!DOCTYPE html>
<html lang="en">
<head>
  <title>Execute Code</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

  <style type="text/css">
    #exec-out {
       color: white,
       background-color: rgb(34, 34, 34);
    }
  </style>
</head>
<body>

  <!-- 
    <div class="jumbotron text-center">
      <h1></h1>
      <p>Resize this responsive page to see the effect!</p> 
    </div> 
  -->
  
<div class="container">
    <div class="row">

      <input style="display:none;" id="fileDialog" type="file" accept=".R,.py" />
      <!-- 
        <div class="col-sm-8 col-md-8 col-lg-8 col-xs-12">
            <form onsubmit="executeCodeNow(event)">
              <div class="form-group">
                  <label for="code">Paste your Python code here</label>
                  <textarea class="form-control" rows="15" id="code"></textarea>
              </div>

              <input type="submit" class="btn btn-success" value="RUN">
            </form>
        </div> 
      -->

      <div class="col-sm-12 col-md-12 col-lg-12 col-xs-12">
        <br>
        <button class="btn btn-success" onclick="chooseFile('#fileDialog')">Choose</button>
      Choose Python/R code file to run (Node API test)</div>
    </div>

    <div class="row">
      <div class="col-xs-12 col-lg-12">
        <hr>
        <p editable='true' id='path' style="height: 100px; width: 100%; display: none"></p>

        <textarea id="content" rows="15" style="width: 100%"></textarea>
       <!--  <hr>
        <input type="submit" class="btn btn-success" value="RUN" onclick="executeCodeNow()"> 
        -->
        <!-- <hr> -->
        <br>
      </div>
      <div class="col-xs-6">
        <h2>Output</h2>
        <textarea id='exec-out' rows="15" style="width: 95%; margin: 3px"></textarea>
      </div>
      <div class="col-xs-6">
        <h2>Error</h2>
        <textarea id="exec-error" rows="15" style="width: 100%; margin: 5px"></textarea>
      </div>
    </div>
</div>

<script type="text/javascript" src="../app/execute-code.js"></script>

<script type="text/javascript">
    function executeCodeNow(event) {
        event.preventDefault();

        // -- Execute code now --
        
        // console.log("<h2>Giraffe</h2>");
        // alert("<h1>Tiger</h1>");
    }
</script>

    <script type="text/javascript">
        function chooseFile(name) {
            const fs = require("fs");
            var chooser = document.querySelector(name);

            console.log(`Selected file`);

            chooser.addEventListener("change", function(evt) {
                console.log(this.value);

                document.getElementById('path').innerHTML = '<br><span style="color: maroon">Selected file: </span> <span style="color:blue">' + this.value + "</span>";

                const content = fs.readFileSync(this.value, {encoding: 'UTF-8'});
                // document.getElementById('h2').style.display = 'block';

                document.getElementById('path').style.display = 'block';
                document.getElementById('content').value = content;

                let extension = this.value.slice(-3, this.value.length);
                console.log(`Extension: ${extension}`);

                if(extension.toLowerCase() === '.py') {
                    executeCode(this.value); 
                } else {
                    executeCodeR(this.value);
                }
                
                chooser.remove
                // return;
            }, false);

            chooser.click();
        }
        // chooseFile('#fileDialog');
    </script>

    <script type="text/javascript">
        function executeCodeR(fullPath) {
            console.log('Got fullpath as: ' + fullPath);

            const { spawn } = require('child_process');
            // const ls = spawn('Rscript', ['main.R']); // ['-lh', '/usr']

            // const ls = spawn('Rscript', ['H:\\RishikeshAgrawani\\Projects\\GenWork\\NW\\genw-dev\\docs\\computations\\main.R']);

            const r = spawn('Rscript', [`${fullPath}`]);

            r.stdout.on('data', (data) => {
                alert(`R success`);
                console.log(`R => stdout: ${data}`);
               
                document.getElementById('exec-out').value = `${data}`;
                document.getElementById('exec-error').value = ``;
            });

            r.stderr.on('data', (data) => {
                alert(`R error`); 

                document.getElementById('exec-out').value = ``;
                document.getElementById('exec-error').value = `${data}`;
                console.log(`R => stderr: ${data}`);
            });

            r.on('close', (code) => {
                console.log(`child process exited with code ${code}`);
            });
        }

    // executeCode();
    </script>
</body>
</html>
